/* --------------------------------------------------------
 * This code was generated automatically by MBsysC modules.
 * MBsysC modules are distributed as part of the ROBOTRAN 
 * software. They provides functionalities for dealing with
 * symbolic equations generated by ROBOTRAN. 
 *
 * More info on www.robotran.be 
 *
 * Universite catholique de Louvain, Belgium 
 *
 * Last update : Tue Jan 30 10:23:08 2024
 * --------------------------------------------------------
 *
 */
#include "mbs_path.h"
#include "user_model.h"
#include "mbs_binder_public.h"
#include "mbs_loader.h"
#include "useful_functions.h"
#include "mbs_message.h"
#include "lut.h"
#include <math.h>
#include <float.h>

// ============================================================ //


UserModel* mbs_new_user_model() 
{
    UserModel* um;
    um = (UserModel*)malloc(sizeof(UserModel));
    um->WHEEL.K = 0.0;
    um->WHEEL.C = 0.0;
    um->WHEEL.rnom = 0.0;
 
    um->SUSP.K = 0.0;
    um->SUSP.C = 0.0;
    um->SUSP.z0 = 0.0;
 
    um->Road.height = 0.0;
 
    return um;
}

void mbs_delete_user_model(UserModel* um) 
{
    free(um);
}

 void mbs_load_user_model(MbsInfos* mbs_infos, UserModel* um) 
{
    int ind_state_value = 1;

    um->WHEEL.K = mbs_infos->user_models->user_model_list[0]->parameter_list[0]->value_list[1];
    um->WHEEL.C = mbs_infos->user_models->user_model_list[0]->parameter_list[1]->value_list[1];
    um->WHEEL.rnom = mbs_infos->user_models->user_model_list[0]->parameter_list[2]->value_list[1];
 
    um->SUSP.K = mbs_infos->user_models->user_model_list[1]->parameter_list[0]->value_list[1];
    um->SUSP.C = mbs_infos->user_models->user_model_list[1]->parameter_list[1]->value_list[1];
    um->SUSP.z0 = mbs_infos->user_models->user_model_list[1]->parameter_list[2]->value_list[1];
 
    um->Road.height = mbs_infos->user_models->user_model_list[2]->parameter_list[0]->value_list[1];
 
}

 void mbs_bind_user_model(MbsInfos* mbs_infos, UserModel* um) 
{
    mbs_infos->user_models->user_model_list[0]->parameter_list[0]->val_ptr = &um->WHEEL.K;
    mbs_infos->user_models->user_model_list[0]->parameter_list[1]->val_ptr = &um->WHEEL.C;
    mbs_infos->user_models->user_model_list[0]->parameter_list[2]->val_ptr = &um->WHEEL.rnom;
 
    mbs_infos->user_models->user_model_list[1]->parameter_list[0]->val_ptr = &um->SUSP.K;
    mbs_infos->user_models->user_model_list[1]->parameter_list[1]->val_ptr = &um->SUSP.C;
    mbs_infos->user_models->user_model_list[1]->parameter_list[2]->val_ptr = &um->SUSP.z0;
 
    mbs_infos->user_models->user_model_list[2]->parameter_list[0]->val_ptr = &um->Road.height;
 
}
 
 void mbs_print_user_model(UserModel* um) 
{

    printf("user_model->WHEEL.K=%f\n", um->WHEEL.K);
    printf("user_model->WHEEL.C=%f\n", um->WHEEL.C);
    printf("user_model->WHEEL.rnom=%f\n", um->WHEEL.rnom);
 
    printf("user_model->SUSP.K=%f\n", um->SUSP.K);
    printf("user_model->SUSP.C=%f\n", um->SUSP.C);
    printf("user_model->SUSP.z0=%f\n", um->SUSP.z0);
 
    printf("user_model->Road.height=%f\n", um->Road.height);
 
}
 
void mbs_get_user_model_size(int *n_user_model) 
{
    *n_user_model  = 3; 
}
 
void mbs_get_user_model_list(int *user_model_list) 
{
    user_model_list[1]  = 3; 
    user_model_list[2]  = 3; 
    user_model_list[3]  = 1; 

}

void mbs_save_um(FILE* stream, UserModel* um)
{
    if (isnan(um->WHEEL.K)) { fprintf(stream, "         s->user_model->WHEEL.K = NAN; \n");}
    else if (isinf(um->WHEEL.K)) { fprintf(stream, "        s->user_model->WHEEL.K = %d * INFINITY; \n", isinf(um->WHEEL.K));}
    else { fprintf(stream, "        s->user_model->WHEEL.K = %.*e;\n", DBL_DECIMAL_DIG - 1, um->WHEEL.K);}
    if (isnan(um->WHEEL.C)) { fprintf(stream, "         s->user_model->WHEEL.C = NAN; \n");}
    else if (isinf(um->WHEEL.C)) { fprintf(stream, "        s->user_model->WHEEL.C = %d * INFINITY; \n", isinf(um->WHEEL.C));}
    else { fprintf(stream, "        s->user_model->WHEEL.C = %.*e;\n", DBL_DECIMAL_DIG - 1, um->WHEEL.C);}
    if (isnan(um->WHEEL.rnom)) { fprintf(stream, "         s->user_model->WHEEL.rnom = NAN; \n");}
    else if (isinf(um->WHEEL.rnom)) { fprintf(stream, "        s->user_model->WHEEL.rnom = %d * INFINITY; \n", isinf(um->WHEEL.rnom));}
    else { fprintf(stream, "        s->user_model->WHEEL.rnom = %.*e;\n", DBL_DECIMAL_DIG - 1, um->WHEEL.rnom);}
 
    if (isnan(um->SUSP.K)) { fprintf(stream, "         s->user_model->SUSP.K = NAN; \n");}
    else if (isinf(um->SUSP.K)) { fprintf(stream, "        s->user_model->SUSP.K = %d * INFINITY; \n", isinf(um->SUSP.K));}
    else { fprintf(stream, "        s->user_model->SUSP.K = %.*e;\n", DBL_DECIMAL_DIG - 1, um->SUSP.K);}
    if (isnan(um->SUSP.C)) { fprintf(stream, "         s->user_model->SUSP.C = NAN; \n");}
    else if (isinf(um->SUSP.C)) { fprintf(stream, "        s->user_model->SUSP.C = %d * INFINITY; \n", isinf(um->SUSP.C));}
    else { fprintf(stream, "        s->user_model->SUSP.C = %.*e;\n", DBL_DECIMAL_DIG - 1, um->SUSP.C);}
    if (isnan(um->SUSP.z0)) { fprintf(stream, "         s->user_model->SUSP.z0 = NAN; \n");}
    else if (isinf(um->SUSP.z0)) { fprintf(stream, "        s->user_model->SUSP.z0 = %d * INFINITY; \n", isinf(um->SUSP.z0));}
    else { fprintf(stream, "        s->user_model->SUSP.z0 = %.*e;\n", DBL_DECIMAL_DIG - 1, um->SUSP.z0);}
 
    if (isnan(um->Road.height)) { fprintf(stream, "         s->user_model->Road.height = NAN; \n");}
    else if (isinf(um->Road.height)) { fprintf(stream, "        s->user_model->Road.height = %d * INFINITY; \n", isinf(um->Road.height));}
    else { fprintf(stream, "        s->user_model->Road.height = %.*e;\n", DBL_DECIMAL_DIG - 1, um->Road.height);}
 
}

// ============================================================ //
 
