%
%-------------------------------------------------------------
%
%	ROBOTRAN - Version 6.6 (build : february 22, 2008)
%
%	Copyright 
%	Universit catholique de Louvain 
%	Dpartement de Mcanique 
%	Unit de Production Mcanique et Machines 
%	2, Place du Levant 
%	1348 Louvain-la-Neuve 
%	http://www.robotran.be// 
%
%	==> Generation Date : Tue Oct 14 13:53:55 2008
%
%	==> Project name : five_point_suspension_matlab
%	==> using XML input file 
%
%	==> Number of joints : 17
%
%	==> Function : F 8 : Constraints Vector (h) and Jacobian Matrix (Jac) 
%	==> Flops complexity : 411
%
%	==> Generation Time :  0.010 seconds
%	==> Post-Processing :  0.010 seconds
%
%-------------------------------------------------------------
%
function [h,Jac] = cons_hJ(s,tsim,usrfun)

 h = zeros(12,1);
 Jac = zeros(12,17);

q = s.q; 
qd = s.qd; 
qdd = s.qdd; 
frc = s.frc; 
trq = s.trq; 

% === begin imp_aux === 

% === end imp_aux === 

% ===== BEGIN task 0 ===== 

% = = Block_0_0_0_0_0_2 = = 
 
% Trigonometric Variables  

C2 = cos(q(2));
S2 = sin(q(2));
C3 = cos(q(3));
S3 = sin(q(3));

% = = Block_0_0_0_0_0_3 = = 
 
% Trigonometric Variables  

C4 = cos(q(4));
S4 = sin(q(4));
C5 = cos(q(5));
S5 = sin(q(5));

% = = Block_0_0_0_0_0_4 = = 
 
% Trigonometric Variables  

C7 = cos(q(7));
S7 = sin(q(7));
C8 = cos(q(8));
S8 = sin(q(8));

% = = Block_0_0_0_0_0_5 = = 
 
% Trigonometric Variables  

C9 = cos(q(9));
S9 = sin(q(9));
C10 = cos(q(10));
S10 = sin(q(10));

% = = Block_0_0_0_0_0_6 = = 
 
% Trigonometric Variables  

C11 = cos(q(11));
S11 = sin(q(11));
C12 = cos(q(12));
S12 = sin(q(12));
C13 = cos(q(13));
S13 = sin(q(13));
C14 = cos(q(14));
S14 = sin(q(14));
C15 = cos(q(15));
S15 = sin(q(15));

% = = Block_0_1_0_0_0_2 = = 
 
% Constraints and Constraints Jacobian 

%
RL_0_118 = -s.dpt(2,8)*S3;
RL_0_218 = s.dpt(2,8)*C2*C3;
RL_0_318 = s.dpt(2,8)*S2*C3;
JT_0_118_3 = -s.dpt(2,8)*C3;
JT_0_218_3 = RL_0_118*C2;
JT_0_318_3 = RL_0_118*S2;

% = = Block_0_1_0_0_0_3 = = 
 
% Constraints and Constraints Jacobian 

%
RL_2_120 = -s.dpt(2,9)*S5;
RL_2_220 = s.dpt(2,9)*C4*C5;
RL_2_320 = s.dpt(2,9)*S4*C5;
JT_2_120_5 = -s.dpt(2,9)*C5;
JT_2_220_5 = RL_2_120*C4;
JT_2_320_5 = RL_2_120*S4;

% = = Block_0_1_0_0_0_4 = = 
 
% Constraints and Constraints Jacobian 

%
RL_4_122 = -s.dpt(2,11)*S8;
RL_4_222 = s.dpt(2,11)*C7*C8;
RL_4_322 = s.dpt(2,11)*S7*C8;
JT_4_122_8 = -s.dpt(2,11)*C8;
JT_4_222_8 = RL_4_122*C7;
JT_4_322_8 = RL_4_122*S7;

% = = Block_0_1_0_0_0_5 = = 
 
% Constraints and Constraints Jacobian 

%
RL_6_124 = -s.dpt(2,12)*S10;
RL_6_224 = s.dpt(2,12)*C10*C9;
RL_6_324 = s.dpt(2,12)*C10*S9;
JT_6_124_10 = -s.dpt(2,12)*C10;
JT_6_224_10 = RL_6_124*C9;
JT_6_324_10 = RL_6_124*S9;

% = = Block_0_1_0_0_0_6 = = 
 
% Constraints and Constraints Jacobian 

%
RO_1_212 = C11*S12;
RO_1_312 = S11*S12;
RO_1_512 = C11*C12;
RO_1_612 = S11*C12;
RO_1_413 = -S12*C13;
RO_1_513 = RO_1_512*C13-S11*S13;
RO_1_613 = RO_1_612*C13+C11*S13;
RO_1_713 = S12*S13;
RO_1_813 = -(RO_1_512*S13+S11*C13);
RO_1_913 = -(RO_1_612*S13-C11*C13);
RO_1_114 = -(RO_1_713*S14-C12*C14);
RO_1_214 = RO_1_212*C14-RO_1_813*S14;
RO_1_314 = RO_1_312*C14-RO_1_913*S14;
RO_1_714 = RO_1_713*C14+C12*S14;
RO_1_814 = RO_1_212*S14+RO_1_813*C14;
RO_1_914 = RO_1_312*S14+RO_1_913*C14;
RO_1_115 = RO_1_114*C15+RO_1_413*S15;
RO_1_215 = RO_1_214*C15+RO_1_513*S15;
RO_1_315 = RO_1_314*C15+RO_1_613*S15;
RO_1_415 = -(RO_1_114*S15-RO_1_413*C15);
RO_1_515 = -(RO_1_214*S15-RO_1_513*C15);
RO_1_615 = -(RO_1_314*S15-RO_1_613*C15);
RL_1_113 = -s.dpt(2,13)*S12;
RL_1_213 = RO_1_512*s.dpt(2,13);
RL_1_313 = RO_1_612*s.dpt(2,13);
PO_1_113 = RL_1_113+s.dpt(1,6);
PO_1_213 = RL_1_213+s.dpt(2,6);
PO_1_313 = RL_1_313+s.dpt(3,6);
JT_1_113_12 = -s.dpt(2,13)*C12;
JT_1_213_12 = RL_1_113*C11;
JT_1_313_12 = RL_1_113*S11;
RL_1_119 = RO_1_115*s.dpt(1,16)+RO_1_415*s.dpt(2,16)+RO_1_714*s.dpt(3,16);
RL_1_219 = RO_1_215*s.dpt(1,16)+RO_1_515*s.dpt(2,16)+RO_1_814*s.dpt(3,16);
RL_1_319 = RO_1_315*s.dpt(1,16)+RO_1_615*s.dpt(2,16)+RO_1_914*s.dpt(3,16);
JT_1_219_11 = -(RL_1_313+RL_1_319);
JT_1_319_11 = RL_1_213+RL_1_219;
JT_1_119_12 = JT_1_113_12-RL_1_219*C11-RL_1_319*S11;
JT_1_219_12 = JT_1_213_12+RL_1_119*C11;
JT_1_319_12 = JT_1_313_12+RL_1_119*S11;
JT_1_119_13 = -(RL_1_219*RO_1_312-RL_1_319*RO_1_212);
JT_1_219_13 = RL_1_119*RO_1_312-RL_1_319*C12;
JT_1_319_13 = -(RL_1_119*RO_1_212-RL_1_219*C12);
JT_1_119_14 = -(RL_1_219*RO_1_613-RL_1_319*RO_1_513);
JT_1_219_14 = RL_1_119*RO_1_613-RL_1_319*RO_1_413;
JT_1_319_14 = -(RL_1_119*RO_1_513-RL_1_219*RO_1_413);
JT_1_119_15 = -(RL_1_219*RO_1_914-RL_1_319*RO_1_814);
JT_1_219_15 = RL_1_119*RO_1_914-RL_1_319*RO_1_714;
JT_1_319_15 = -(RL_1_119*RO_1_814-RL_1_219*RO_1_714);
%
RL_3_121 = RO_1_115*s.dpt(1,17)+RO_1_415*s.dpt(2,17)+RO_1_714*s.dpt(3,17);
RL_3_221 = RO_1_215*s.dpt(1,17)+RO_1_515*s.dpt(2,17)+RO_1_814*s.dpt(3,17);
RL_3_321 = RO_1_315*s.dpt(1,17)+RO_1_615*s.dpt(2,17)+RO_1_914*s.dpt(3,17);
JT_3_221_11 = -(RL_1_313+RL_3_321);
JT_3_321_11 = RL_1_213+RL_3_221;
JT_3_121_12 = JT_1_113_12-RL_3_221*C11-RL_3_321*S11;
JT_3_221_12 = JT_1_213_12+RL_3_121*C11;
JT_3_321_12 = JT_1_313_12+RL_3_121*S11;
JT_3_121_13 = -(RL_3_221*RO_1_312-RL_3_321*RO_1_212);
JT_3_221_13 = RL_3_121*RO_1_312-RL_3_321*C12;
JT_3_321_13 = -(RL_3_121*RO_1_212-RL_3_221*C12);
JT_3_121_14 = -(RL_3_221*RO_1_613-RL_3_321*RO_1_513);
JT_3_221_14 = RL_3_121*RO_1_613-RL_3_321*RO_1_413;
JT_3_321_14 = -(RL_3_121*RO_1_513-RL_3_221*RO_1_413);
JT_3_121_15 = -(RL_3_221*RO_1_914-RL_3_321*RO_1_814);
JT_3_221_15 = RL_3_121*RO_1_914-RL_3_321*RO_1_714;
JT_3_321_15 = -(RL_3_121*RO_1_814-RL_3_221*RO_1_714);
%
RL_5_123 = RO_1_115*s.dpt(1,18)+RO_1_415*s.dpt(2,18)+RO_1_714*s.dpt(3,18);
RL_5_223 = RO_1_215*s.dpt(1,18)+RO_1_515*s.dpt(2,18)+RO_1_814*s.dpt(3,18);
RL_5_323 = RO_1_315*s.dpt(1,18)+RO_1_615*s.dpt(2,18)+RO_1_914*s.dpt(3,18);
JT_5_223_11 = -(RL_1_313+RL_5_323);
JT_5_323_11 = RL_1_213+RL_5_223;
JT_5_123_12 = JT_1_113_12-RL_5_223*C11-RL_5_323*S11;
JT_5_223_12 = JT_1_213_12+RL_5_123*C11;
JT_5_323_12 = JT_1_313_12+RL_5_123*S11;
JT_5_123_13 = -(RL_5_223*RO_1_312-RL_5_323*RO_1_212);
JT_5_223_13 = RL_5_123*RO_1_312-RL_5_323*C12;
JT_5_323_13 = -(RL_5_123*RO_1_212-RL_5_223*C12);
JT_5_123_14 = -(RL_5_223*RO_1_613-RL_5_323*RO_1_513);
JT_5_223_14 = RL_5_123*RO_1_613-RL_5_323*RO_1_413;
JT_5_323_14 = -(RL_5_123*RO_1_513-RL_5_223*RO_1_413);
JT_5_123_15 = -(RL_5_223*RO_1_914-RL_5_323*RO_1_814);
JT_5_223_15 = RL_5_123*RO_1_914-RL_5_323*RO_1_714;
JT_5_323_15 = -(RL_5_123*RO_1_814-RL_5_223*RO_1_714);
%
RL_7_125 = RO_1_115*s.dpt(1,19)+RO_1_415*s.dpt(2,19)+RO_1_714*s.dpt(3,19);
RL_7_225 = RO_1_215*s.dpt(1,19)+RO_1_515*s.dpt(2,19)+RO_1_814*s.dpt(3,19);
RL_7_325 = RO_1_315*s.dpt(1,19)+RO_1_615*s.dpt(2,19)+RO_1_914*s.dpt(3,19);
JT_7_225_11 = -(RL_1_313+RL_7_325);
JT_7_325_11 = RL_1_213+RL_7_225;
JT_7_125_12 = JT_1_113_12-RL_7_225*C11-RL_7_325*S11;
JT_7_225_12 = JT_1_213_12+RL_7_125*C11;
JT_7_325_12 = JT_1_313_12+RL_7_125*S11;
JT_7_125_13 = -(RL_7_225*RO_1_312-RL_7_325*RO_1_212);
JT_7_225_13 = RL_7_125*RO_1_312-RL_7_325*C12;
JT_7_325_13 = -(RL_7_125*RO_1_212-RL_7_225*C12);
JT_7_125_14 = -(RL_7_225*RO_1_613-RL_7_325*RO_1_513);
JT_7_225_14 = RL_7_125*RO_1_613-RL_7_325*RO_1_413;
JT_7_325_14 = -(RL_7_125*RO_1_513-RL_7_225*RO_1_413);
JT_7_125_15 = -(RL_7_225*RO_1_914-RL_7_325*RO_1_814);
JT_7_225_15 = RL_7_125*RO_1_914-RL_7_325*RO_1_714;
JT_7_325_15 = -(RL_7_125*RO_1_814-RL_7_225*RO_1_714);

% = = Block_0_1_0_0_1_0 = = 
 
% Constraints and Constraints Jacobian 

%
h_1 = RL_0_118+s.dpt(1,2)-(PO_1_113+RL_1_119);
h_2 = RL_0_218+s.dpt(2,2)-(PO_1_213+RL_1_219);
h_3 = RL_0_318+s.dpt(3,2)-(PO_1_313+RL_1_319);
%
h_4 = RL_2_120+s.dpt(1,3)-(PO_1_113+RL_3_121);
h_5 = RL_2_220+s.dpt(2,3)-(PO_1_213+RL_3_221);
h_6 = RL_2_320+s.dpt(3,3)-(PO_1_313+RL_3_321);
%
h_7 = RL_4_122+s.dpt(1,4)-(PO_1_113+RL_5_123);
h_8 = RL_4_222+q(6)+s.dpt(2,10)-(PO_1_213+RL_5_223);
h_9 = RL_4_322+s.dpt(3,4)-(PO_1_313+RL_5_323);
%
h_10 = RL_6_124+s.dpt(1,5)-(PO_1_113+RL_7_125);
h_11 = RL_6_224+s.dpt(2,5)-(PO_1_213+RL_7_225);
h_12 = RL_6_324+s.dpt(3,5)-(PO_1_313+RL_7_325);

% = = Block_0_3_0_0_0_0 = = 
 
% Symbolic Outputs  

h(1) = h_1;
h(2) = h_2;
h(3) = h_3;
h(4) = h_4;
h(5) = h_5;
h(6) = h_6;
h(7) = h_7;
h(8) = h_8;
h(9) = h_9;
h(10) = h_10;
h(11) = h_11;
h(12) = h_12;
Jac(1,3) = JT_0_118_3;
Jac(1,12) = -JT_1_119_12;
Jac(1,13) = -JT_1_119_13;
Jac(1,14) = -JT_1_119_14;
Jac(1,15) = -JT_1_119_15;
Jac(2,2) = -RL_0_318;
Jac(2,3) = JT_0_218_3;
Jac(2,11) = -JT_1_219_11;
Jac(2,12) = -JT_1_219_12;
Jac(2,13) = -JT_1_219_13;
Jac(2,14) = -JT_1_219_14;
Jac(2,15) = -JT_1_219_15;
Jac(3,2) = RL_0_218;
Jac(3,3) = JT_0_318_3;
Jac(3,11) = -JT_1_319_11;
Jac(3,12) = -JT_1_319_12;
Jac(3,13) = -JT_1_319_13;
Jac(3,14) = -JT_1_319_14;
Jac(3,15) = -JT_1_319_15;
Jac(4,5) = JT_2_120_5;
Jac(4,12) = -JT_3_121_12;
Jac(4,13) = -JT_3_121_13;
Jac(4,14) = -JT_3_121_14;
Jac(4,15) = -JT_3_121_15;
Jac(5,4) = -RL_2_320;
Jac(5,5) = JT_2_220_5;
Jac(5,11) = -JT_3_221_11;
Jac(5,12) = -JT_3_221_12;
Jac(5,13) = -JT_3_221_13;
Jac(5,14) = -JT_3_221_14;
Jac(5,15) = -JT_3_221_15;
Jac(6,4) = RL_2_220;
Jac(6,5) = JT_2_320_5;
Jac(6,11) = -JT_3_321_11;
Jac(6,12) = -JT_3_321_12;
Jac(6,13) = -JT_3_321_13;
Jac(6,14) = -JT_3_321_14;
Jac(6,15) = -JT_3_321_15;
Jac(7,8) = JT_4_122_8;
Jac(7,12) = -JT_5_123_12;
Jac(7,13) = -JT_5_123_13;
Jac(7,14) = -JT_5_123_14;
Jac(7,15) = -JT_5_123_15;
Jac(8,6) = (1.0);
Jac(8,7) = -RL_4_322;
Jac(8,8) = JT_4_222_8;
Jac(8,11) = -JT_5_223_11;
Jac(8,12) = -JT_5_223_12;
Jac(8,13) = -JT_5_223_13;
Jac(8,14) = -JT_5_223_14;
Jac(8,15) = -JT_5_223_15;
Jac(9,7) = RL_4_222;
Jac(9,8) = JT_4_322_8;
Jac(9,11) = -JT_5_323_11;
Jac(9,12) = -JT_5_323_12;
Jac(9,13) = -JT_5_323_13;
Jac(9,14) = -JT_5_323_14;
Jac(9,15) = -JT_5_323_15;
Jac(10,10) = JT_6_124_10;
Jac(10,12) = -JT_7_125_12;
Jac(10,13) = -JT_7_125_13;
Jac(10,14) = -JT_7_125_14;
Jac(10,15) = -JT_7_125_15;
Jac(11,9) = -RL_6_324;
Jac(11,10) = JT_6_224_10;
Jac(11,11) = -JT_7_225_11;
Jac(11,12) = -JT_7_225_12;
Jac(11,13) = -JT_7_225_13;
Jac(11,14) = -JT_7_225_14;
Jac(11,15) = -JT_7_225_15;
Jac(12,9) = RL_6_224;
Jac(12,10) = JT_6_324_10;
Jac(12,11) = -JT_7_325_11;
Jac(12,12) = -JT_7_325_12;
Jac(12,13) = -JT_7_325_13;
Jac(12,14) = -JT_7_325_14;
Jac(12,15) = -JT_7_325_15;

% ====== END Task 0 ====== 

  

