%
%-------------------------------------------------------------
%
%	ROBOTRAN - Version 6.6 (build : february 22, 2008)
%
%	Copyright 
%	Universit catholique de Louvain 
%	Dpartement de Mcanique 
%	Unit de Production Mcanique et Machines 
%	2, Place du Levant 
%	1348 Louvain-la-Neuve 
%	http://www.robotran.be// 
%
%	==> Generation Date : Tue Oct 14 13:53:55 2008
%
%	==> Project name : five_point_suspension_matlab
%	==> using XML input file 
%
%	==> Number of joints : 17
%
%	==> Function : F18 : Constraints Quadratic Velocity Terms (Jdqd)
%	==> Flops complexity : 569
%
%	==> Generation Time :  0.010 seconds
%	==> Post-Processing :  0.010 seconds
%
%-------------------------------------------------------------
%
function [Jdqd] = cons_jdqd(s,tsim,usrfun)

 Jdqd = zeros(12,1);

q = s.q; 
qd = s.qd; 
qdd = s.qdd; 
frc = s.frc; 
trq = s.trq; 

% === begin imp_aux === 

% === end imp_aux === 

% ===== BEGIN task 0 ===== 

% = = Block_0_0_0_0_0_2 = = 
 
% Trigonometric Variables  

C2 = cos(q(2));
S2 = sin(q(2));
C3 = cos(q(3));
S3 = sin(q(3));

% = = Block_0_0_0_0_0_3 = = 
 
% Trigonometric Variables  

C4 = cos(q(4));
S4 = sin(q(4));
C5 = cos(q(5));
S5 = sin(q(5));

% = = Block_0_0_0_0_0_4 = = 
 
% Trigonometric Variables  

C7 = cos(q(7));
S7 = sin(q(7));
C8 = cos(q(8));
S8 = sin(q(8));

% = = Block_0_0_0_0_0_5 = = 
 
% Trigonometric Variables  

C9 = cos(q(9));
S9 = sin(q(9));
C10 = cos(q(10));
S10 = sin(q(10));

% = = Block_0_0_0_0_0_6 = = 
 
% Trigonometric Variables  

C11 = cos(q(11));
S11 = sin(q(11));
C12 = cos(q(12));
S12 = sin(q(12));
C13 = cos(q(13));
S13 = sin(q(13));
C14 = cos(q(14));
S14 = sin(q(14));
C15 = cos(q(15));
S15 = sin(q(15));

% = = Block_0_1_0_0_0_2 = = 
 
% Constraints and Constraints Jacobian 

%
RL_0_118 = -s.dpt(2,8)*S3;
RL_0_218 = s.dpt(2,8)*C2*C3;
RL_0_318 = s.dpt(2,8)*S2*C3;

% = = Block_0_1_0_0_0_3 = = 
 
% Constraints and Constraints Jacobian 

%
RL_2_120 = -s.dpt(2,9)*S5;
RL_2_220 = s.dpt(2,9)*C4*C5;
RL_2_320 = s.dpt(2,9)*S4*C5;

% = = Block_0_1_0_0_0_4 = = 
 
% Constraints and Constraints Jacobian 

%
RL_4_122 = -s.dpt(2,11)*S8;
RL_4_222 = s.dpt(2,11)*C7*C8;
RL_4_322 = s.dpt(2,11)*S7*C8;

% = = Block_0_1_0_0_0_5 = = 
 
% Constraints and Constraints Jacobian 

%
RL_6_124 = -s.dpt(2,12)*S10;
RL_6_224 = s.dpt(2,12)*C10*C9;
RL_6_324 = s.dpt(2,12)*C10*S9;

% = = Block_0_1_0_0_0_6 = = 
 
% Constraints and Constraints Jacobian 

%
RO_1_212 = C11*S12;
RO_1_312 = S11*S12;
RO_1_512 = C11*C12;
RO_1_612 = S11*C12;
RO_1_413 = -S12*C13;
RO_1_513 = RO_1_512*C13-S11*S13;
RO_1_613 = RO_1_612*C13+C11*S13;
RO_1_713 = S12*S13;
RO_1_813 = -(RO_1_512*S13+S11*C13);
RO_1_913 = -(RO_1_612*S13-C11*C13);
RO_1_114 = -(RO_1_713*S14-C12*C14);
RO_1_214 = RO_1_212*C14-RO_1_813*S14;
RO_1_314 = RO_1_312*C14-RO_1_913*S14;
RO_1_714 = RO_1_713*C14+C12*S14;
RO_1_814 = RO_1_212*S14+RO_1_813*C14;
RO_1_914 = RO_1_312*S14+RO_1_913*C14;
RO_1_115 = RO_1_114*C15+RO_1_413*S15;
RO_1_215 = RO_1_214*C15+RO_1_513*S15;
RO_1_315 = RO_1_314*C15+RO_1_613*S15;
RO_1_415 = -(RO_1_114*S15-RO_1_413*C15);
RO_1_515 = -(RO_1_214*S15-RO_1_513*C15);
RO_1_615 = -(RO_1_314*S15-RO_1_613*C15);
RL_1_113 = -s.dpt(2,13)*S12;
RL_1_213 = RO_1_512*s.dpt(2,13);
RL_1_313 = RO_1_612*s.dpt(2,13);
RL_1_119 = RO_1_115*s.dpt(1,16)+RO_1_415*s.dpt(2,16)+RO_1_714*s.dpt(3,16);
RL_1_219 = RO_1_215*s.dpt(1,16)+RO_1_515*s.dpt(2,16)+RO_1_814*s.dpt(3,16);
RL_1_319 = RO_1_315*s.dpt(1,16)+RO_1_615*s.dpt(2,16)+RO_1_914*s.dpt(3,16);
%
RL_3_121 = RO_1_115*s.dpt(1,17)+RO_1_415*s.dpt(2,17)+RO_1_714*s.dpt(3,17);
RL_3_221 = RO_1_215*s.dpt(1,17)+RO_1_515*s.dpt(2,17)+RO_1_814*s.dpt(3,17);
RL_3_321 = RO_1_315*s.dpt(1,17)+RO_1_615*s.dpt(2,17)+RO_1_914*s.dpt(3,17);
%
RL_5_123 = RO_1_115*s.dpt(1,18)+RO_1_415*s.dpt(2,18)+RO_1_714*s.dpt(3,18);
RL_5_223 = RO_1_215*s.dpt(1,18)+RO_1_515*s.dpt(2,18)+RO_1_814*s.dpt(3,18);
RL_5_323 = RO_1_315*s.dpt(1,18)+RO_1_615*s.dpt(2,18)+RO_1_914*s.dpt(3,18);
%
RL_7_125 = RO_1_115*s.dpt(1,19)+RO_1_415*s.dpt(2,19)+RO_1_714*s.dpt(3,19);
RL_7_225 = RO_1_215*s.dpt(1,19)+RO_1_515*s.dpt(2,19)+RO_1_814*s.dpt(3,19);
RL_7_325 = RO_1_315*s.dpt(1,19)+RO_1_615*s.dpt(2,19)+RO_1_914*s.dpt(3,19);

% = = Block_0_2_0_0_0_0 = = 
 
% Constraints Quadratic Terms 

%
OM_0_23 = -qd(3)*S2;
OM_0_33 = qd(3)*C2;
Ompqp_0_23 = -qd(2)*qd(3)*C2;
Ompqp_0_33 = -qd(2)*qd(3)*S2;
OR_0_118 = -qd(3)*s.dpt(2,8)*C3;
OR_0_218 = OM_0_33*RL_0_118-RL_0_318*qd(2);
OR_0_318 = -(OM_0_23*RL_0_118-RL_0_218*qd(2));
%
OM_1_212 = -qd(12)*S11;
OM_1_312 = qd(12)*C11;
Ompqp_1_212 = -qd(11)*qd(12)*C11;
Ompqp_1_312 = -qd(11)*qd(12)*S11;
OM_1_113 = qd(11)+qd(13)*C12;
OM_1_213 = OM_1_212+RO_1_212*qd(13);
OM_1_313 = OM_1_312+RO_1_312*qd(13);
OR_1_113 = -qd(12)*s.dpt(2,13)*C12;
OR_1_213 = OM_1_312*RL_1_113-RL_1_313*qd(11);
OR_1_313 = -(OM_1_212*RL_1_113-RL_1_213*qd(11));
Apqp_1_113 = OM_1_212*OR_1_313-OM_1_312*OR_1_213+Ompqp_1_212*RL_1_313-Ompqp_1_312*RL_1_213;
Apqp_1_213 = OM_1_312*OR_1_113-OR_1_313*qd(11)+Ompqp_1_312*RL_1_113;
Apqp_1_313 = -(OM_1_212*OR_1_113-OR_1_213*qd(11)+Ompqp_1_212*RL_1_113);
OM_1_114 = OM_1_113+RO_1_413*qd(14);
OM_1_214 = OM_1_213+RO_1_513*qd(14);
OM_1_314 = OM_1_313+RO_1_613*qd(14);
OM_1_115 = OM_1_114+RO_1_714*qd(15);
OM_1_215 = OM_1_214+RO_1_814*qd(15);
OM_1_315 = OM_1_314+RO_1_914*qd(15);
Ompqp_1_115 = -(qd(12)*qd(13)*S12-qd(14)*(OM_1_213*RO_1_613-OM_1_313*RO_1_513)-qd(15)*(OM_1_214*RO_1_914-OM_1_314*RO_1_814));
Ompqp_1_215 = Ompqp_1_212+qd(13)*(OM_1_312*C12-RO_1_312*qd(11))-qd(14)*(OM_1_113*RO_1_613-OM_1_313*RO_1_413)-qd(15)*(OM_1_114*RO_1_914-OM_1_314...
 *RO_1_714);
Ompqp_1_315 = Ompqp_1_312-qd(13)*(OM_1_212*C12-RO_1_212*qd(11))+qd(14)*(OM_1_113*RO_1_513-OM_1_213*RO_1_413)+qd(15)*(OM_1_114*RO_1_814-OM_1_214...
 *RO_1_714);
OR_1_119 = OM_1_215*RL_1_319-OM_1_315*RL_1_219;
OR_1_219 = -(OM_1_115*RL_1_319-OM_1_315*RL_1_119);
OR_1_319 = OM_1_115*RL_1_219-OM_1_215*RL_1_119;
%
OM_2_25 = -qd(5)*S4;
OM_2_35 = qd(5)*C4;
Ompqp_2_25 = -qd(4)*qd(5)*C4;
Ompqp_2_35 = -qd(4)*qd(5)*S4;
OR_2_120 = -qd(5)*s.dpt(2,9)*C5;
OR_2_220 = OM_2_35*RL_2_120-RL_2_320*qd(4);
OR_2_320 = -(OM_2_25*RL_2_120-RL_2_220*qd(4));
%
OR_3_121 = OM_1_215*RL_3_321-OM_1_315*RL_3_221;
OR_3_221 = -(OM_1_115*RL_3_321-OM_1_315*RL_3_121);
OR_3_321 = OM_1_115*RL_3_221-OM_1_215*RL_3_121;
%
OM_4_28 = -qd(8)*S7;
OM_4_38 = qd(8)*C7;
Ompqp_4_28 = -qd(7)*qd(8)*C7;
Ompqp_4_38 = -qd(7)*qd(8)*S7;
OR_4_122 = -qd(8)*s.dpt(2,11)*C8;
OR_4_222 = OM_4_38*RL_4_122-RL_4_322*qd(7);
OR_4_322 = -(OM_4_28*RL_4_122-RL_4_222*qd(7));
%
OR_5_123 = OM_1_215*RL_5_323-OM_1_315*RL_5_223;
OR_5_223 = -(OM_1_115*RL_5_323-OM_1_315*RL_5_123);
OR_5_323 = OM_1_115*RL_5_223-OM_1_215*RL_5_123;
%
OM_6_210 = -qd(10)*S9;
OM_6_310 = qd(10)*C9;
Ompqp_6_210 = -qd(10)*qd(9)*C9;
Ompqp_6_310 = -qd(10)*qd(9)*S9;
OR_6_124 = -qd(10)*s.dpt(2,12)*C10;
OR_6_224 = OM_6_310*RL_6_124-RL_6_324*qd(9);
OR_6_324 = -(OM_6_210*RL_6_124-RL_6_224*qd(9));
%
OR_7_125 = OM_1_215*RL_7_325-OM_1_315*RL_7_225;
OR_7_225 = -(OM_1_115*RL_7_325-OM_1_315*RL_7_125);
OR_7_325 = OM_1_115*RL_7_225-OM_1_215*RL_7_125;

% = = Block_0_2_0_0_0_1 = = 
 
% Constraints Quadratic Terms 

%
jdqd1 = OM_0_23*OR_0_318-OM_0_33*OR_0_218+Ompqp_0_23*RL_0_318-Ompqp_0_33*RL_0_218-(Apqp_1_113+OM_1_215*OR_1_319-OM_1_315*OR_1_219+Ompqp_1_215*...
 RL_1_319-Ompqp_1_315*RL_1_219);
jdqd2 = OM_0_33*OR_0_118-OR_0_318*qd(2)+Ompqp_0_33*RL_0_118-(Apqp_1_213-OM_1_115*OR_1_319+OM_1_315*OR_1_119-Ompqp_1_115*RL_1_319+Ompqp_1_315*...
 RL_1_119);
jdqd3 = -(Apqp_1_313+OM_0_23*OR_0_118+OM_1_115*OR_1_219-OM_1_215*OR_1_119-OR_0_218*qd(2)+Ompqp_0_23*RL_0_118+Ompqp_1_115*RL_1_219-Ompqp_1_215*...
 RL_1_119);
%
jdqd4 = OM_2_25*OR_2_320-OM_2_35*OR_2_220+Ompqp_2_25*RL_2_320-Ompqp_2_35*RL_2_220-(Apqp_1_113+OM_1_215*OR_3_321-OM_1_315*OR_3_221+Ompqp_1_215*...
 RL_3_321-Ompqp_1_315*RL_3_221);
jdqd5 = OM_2_35*OR_2_120-OR_2_320*qd(4)+Ompqp_2_35*RL_2_120-(Apqp_1_213-OM_1_115*OR_3_321+OM_1_315*OR_3_121-Ompqp_1_115*RL_3_321+Ompqp_1_315*...
 RL_3_121);
jdqd6 = -(Apqp_1_313+OM_1_115*OR_3_221-OM_1_215*OR_3_121+OM_2_25*OR_2_120-OR_2_220*qd(4)+Ompqp_1_115*RL_3_221-Ompqp_1_215*RL_3_121+Ompqp_2_25*...
 RL_2_120);
%
jdqd7 = OM_4_28*OR_4_322-OM_4_38*OR_4_222+Ompqp_4_28*RL_4_322-Ompqp_4_38*RL_4_222-(Apqp_1_113+OM_1_215*OR_5_323-OM_1_315*OR_5_223+Ompqp_1_215*...
 RL_5_323-Ompqp_1_315*RL_5_223);
jdqd8 = OM_4_38*OR_4_122-OR_4_322*qd(7)+Ompqp_4_38*RL_4_122-(Apqp_1_213-OM_1_115*OR_5_323+OM_1_315*OR_5_123-Ompqp_1_115*RL_5_323+Ompqp_1_315*...
 RL_5_123);
jdqd9 = -(Apqp_1_313+OM_1_115*OR_5_223-OM_1_215*OR_5_123+OM_4_28*OR_4_122-OR_4_222*qd(7)+Ompqp_1_115*RL_5_223-Ompqp_1_215*RL_5_123+Ompqp_4_28*...
 RL_4_122);
%
jdqd10 = OM_6_210*OR_6_324-OM_6_310*OR_6_224+Ompqp_6_210*RL_6_324-Ompqp_6_310*RL_6_224-(Apqp_1_113+OM_1_215*OR_7_325-OM_1_315*OR_7_225+...
 Ompqp_1_215*RL_7_325-Ompqp_1_315*RL_7_225);
jdqd11 = OM_6_310*OR_6_124-OR_6_324*qd(9)+Ompqp_6_310*RL_6_124-(Apqp_1_213-OM_1_115*OR_7_325+OM_1_315*OR_7_125-Ompqp_1_115*RL_7_325+Ompqp_1_315...
 *RL_7_125);
jdqd12 = -(Apqp_1_313+OM_1_115*OR_7_225-OM_1_215*OR_7_125+OM_6_210*OR_6_124-OR_6_224*qd(9)+Ompqp_1_115*RL_7_225-Ompqp_1_215*RL_7_125+...
 Ompqp_6_210*RL_6_124);

% = = Block_0_3_0_0_0_0 = = 
 
% Symbolic Outputs  

Jdqd(1) = jdqd1;
Jdqd(2) = jdqd2;
Jdqd(3) = jdqd3;
Jdqd(4) = jdqd4;
Jdqd(5) = jdqd5;
Jdqd(6) = jdqd6;
Jdqd(7) = jdqd7;
Jdqd(8) = jdqd8;
Jdqd(9) = jdqd9;
Jdqd(10) = jdqd10;
Jdqd(11) = jdqd11;
Jdqd(12) = jdqd12;

% ====== END Task 0 ====== 

  

