%
%-------------------------------------------------------------
%
%	ROBOTRAN - Version 6.6 (build : february 22, 2008)
%
%	Copyright 
%	Universit catholique de Louvain 
%	Dpartement de Mcanique 
%	Unit de Production Mcanique et Machines 
%	2, Place du Levant 
%	1348 Louvain-la-Neuve 
%	http://www.robotran.be// 
%
%	==> Generation Date : Tue Oct 14 13:53:55 2008
%
%	==> Project name : five_point_suspension_matlab
%	==> using XML input file 
%
%	==> Number of joints : 17
%
%	==> Function : F 2 : Inverse Dynamics : RNEA
%	==> Flops complexity : 583
%
%	==> Generation Time :  0.010 seconds
%	==> Post-Processing :  0.010 seconds
%
%-------------------------------------------------------------
%
function [Qq] = invdyna(s,tsim,usrfun)

 Qq = zeros(17,1);

q = s.q; 
qd = s.qd; 
qdd = s.qdd; 
frc = s.frc; 
trq = s.trq; 

% === begin imp_aux === 

% === end imp_aux === 

% ===== BEGIN task 0 ===== 

% = = Block_0_0_0_0_0_2 = = 
 
% Trigonometric Variables  

C2 = cos(q(2));
S2 = sin(q(2));
C3 = cos(q(3));
S3 = sin(q(3));

% = = Block_0_0_0_0_0_3 = = 
 
% Trigonometric Variables  

C4 = cos(q(4));
S4 = sin(q(4));
C5 = cos(q(5));
S5 = sin(q(5));

% = = Block_0_0_0_0_0_4 = = 
 
% Trigonometric Variables  

C7 = cos(q(7));
S7 = sin(q(7));
C8 = cos(q(8));
S8 = sin(q(8));

% = = Block_0_0_0_0_0_5 = = 
 
% Trigonometric Variables  

C9 = cos(q(9));
S9 = sin(q(9));
C10 = cos(q(10));
S10 = sin(q(10));

% = = Block_0_0_0_0_0_6 = = 
 
% Trigonometric Variables  

C11 = cos(q(11));
S11 = sin(q(11));
C12 = cos(q(12));
S12 = sin(q(12));
C13 = cos(q(13));
S13 = sin(q(13));
C14 = cos(q(14));
S14 = sin(q(14));
C15 = cos(q(15));
S15 = sin(q(15));
C16 = cos(q(16));
S16 = sin(q(16));

% = = Block_0_1_0_0_0_0 = = 
 
% Forward Kinematics 

ALPHA31 = qdd(1)-s.g(3);
ALPHA22 = ALPHA31*S2;
OM13 = qd(2)*C3;
OM23 = -qd(2)*S3;
ALPHA24 = ALPHA31*S4;
OM15 = qd(4)*C5;
OM25 = -qd(4)*S5;
ALPHA27 = qdd(6)*C7+ALPHA31*S7;
OM18 = qd(7)*C8;
OM28 = -qd(7)*S8;
ALPHA29 = ALPHA31*S9;
OM110 = qd(9)*C10;
OM210 = -qd(9)*S10;
ALPHA211 = ALPHA31*S11;
ALPHA311 = ALPHA31*C11;
OM112 = qd(11)*C12;
OM212 = -qd(11)*S12;
OMp112 = -(qd(11)*qd(12)*S12-qdd(11)*C12);
OMp212 = -(qd(11)*qd(12)*C12+qdd(11)*S12);
BS512 = -(qd(12)*qd(12)+OM112*OM112);
BETA212 = -(qdd(12)-OM112*OM212);
BETA812 = OMp112+qd(12)*OM212;
ALPHA112 = ALPHA211*S12;
ALPHA212 = ALPHA211*C12;
OM113 = qd(13)+OM112;
OM313 = qd(12)*C13-OM212*S13;
OMp113 = qdd(13)+OMp112;
OMp313 = C13*(qdd(12)-qd(13)*OM212)-S13*(OMp212+qd(12)*qd(13));
ALPHA113 = ALPHA112+BETA212*s.dpt(2,13);
ALPHA213 = C13*(ALPHA212+BS512*s.dpt(2,13))+S13*(ALPHA311+BETA812*s.dpt(2,13));
ALPHA313 = C13*(ALPHA311+BETA812*s.dpt(2,13))-S13*(ALPHA212+BS512*s.dpt(2,13));
OM114 = OM113*C14-OM313*S14;
OM214 = qd(14)+qd(12)*S13+OM212*C13;
OMp114 = C14*(OMp113-qd(14)*OM313)-S14*(OMp313+qd(14)*OM113);
OMp214 = qdd(14)+C13*(OMp212+qd(12)*qd(13))+S13*(qdd(12)-qd(13)*OM212);
ALPHA114 = ALPHA113*C14-ALPHA313*S14;
ALPHA314 = ALPHA113*S14+ALPHA313*C14;
OM115 = OM114*C15+OM214*S15;
OM215 = -(OM114*S15-OM214*C15);
OM315 = qd(15)+OM113*S14+OM313*C14;
OMp115 = C15*(OMp114+qd(15)*OM214)+S15*(OMp214-qd(15)*OM114);
OMp215 = C15*(OMp214-qd(15)*OM114)-S15*(OMp114+qd(15)*OM214);
OMp315 = qdd(15)+C14*(OMp313+qd(14)*OM113)+S14*(OMp113-qd(14)*OM313);
BS115 = -(OM215*OM215+OM315*OM315);
BS215 = OM115*OM215;
BS315 = OM115*OM315;
BS515 = -(OM115*OM115+OM315*OM315);
BS615 = OM215*OM315;
BS915 = -(OM115*OM115+OM215*OM215);
BETA215 = BS215-OMp315;
BETA315 = BS315+OMp215;
BETA415 = BS215+OMp315;
BETA615 = BS615-OMp115;
BETA715 = BS315-OMp215;
BETA815 = BS615+OMp115;
ALPHA115 = ALPHA114*C15+ALPHA213*S15;
ALPHA215 = -(ALPHA114*S15-ALPHA213*C15);
 
% Backward Dynamics 

Fs116 = -(s.frc(1,16)-s.m(16)*(C16*(ALPHA115+BETA215*s.dpt(2,15)+BETA315*s.dpt(3,15)+BS115*s.dpt(1,15))-S16*(ALPHA314+BETA715*s.dpt(1,15)+...
 BETA815*s.dpt(2,15)+BS915*s.dpt(3,15))));
Fs216 = -(s.frc(2,16)-s.m(16)*(ALPHA215+BETA415*s.dpt(1,15)+BETA615*s.dpt(3,15)+BS515*s.dpt(2,15)));
Fs316 = -(s.frc(3,16)-s.m(16)*(C16*(ALPHA314+BETA715*s.dpt(1,15)+BETA815*s.dpt(2,15)+BS915*s.dpt(3,15))+S16*(ALPHA115+BETA215*s.dpt(2,15)+...
 BETA315*s.dpt(3,15)+BS115*s.dpt(1,15))));
Fs115 = -(s.frc(1,15)-s.m(15)*(ALPHA115+BETA215*s.l(2,15)+BETA315*s.l(3,15)+BS115*s.l(1,15)));
Fs215 = -(s.frc(2,15)-s.m(15)*(ALPHA215+BETA415*s.l(1,15)+BETA615*s.l(3,15)+BS515*s.l(2,15)));
Fs315 = -(s.frc(3,15)-s.m(15)*(ALPHA314+BETA715*s.l(1,15)+BETA815*s.l(2,15)+BS915*s.l(3,15)));
Fq115 = Fs115+Fs116*C16+Fs316*S16;
Fq215 = Fs215+Fs216;
Fq315 = Fs315-Fs116*S16+Fs316*C16;
Cq115 = -(s.trq(1,15)+s.trq(1,16)*C16+s.trq(3,16)*S16+Fs215*s.l(3,15)+Fs216*s.dpt(3,15)-Fs315*s.l(2,15)+s.dpt(2,15)*(Fs116*S16-Fs316*C16));
Cq215 = -(s.trq(2,15)+s.trq(2,16)-Fs115*s.l(3,15)+Fs315*s.l(1,15)-s.dpt(1,15)*(Fs116*S16-Fs316*C16)-s.dpt(3,15)*(Fs116*C16+Fs316*S16));
Cq315 = -(s.trq(3,15)-s.trq(1,16)*S16+s.trq(3,16)*C16+Fs115*s.l(2,15)-Fs215*s.l(1,15)-Fs216*s.dpt(1,15)+s.dpt(2,15)*(Fs116*C16+Fs316*S16));
Fq114 = Fq115*C15-Fq215*S15;
Fq214 = Fq115*S15+Fq215*C15;
Cq114 = Cq115*C15-Cq215*S15;
Cq214 = Cq115*S15+Cq215*C15;
Fq113 = Fq114*C14+Fq315*S14;
Fq313 = -(Fq114*S14-Fq315*C14);
Cq113 = Cq114*C14+Cq315*S14;
Cq313 = -(Cq114*S14-Cq315*C14);
Fs112 = -(s.frc(1,12)-s.m(12)*(ALPHA112+BETA212*s.l(2,12)));
Fs312 = -(s.frc(3,12)-s.m(12)*(ALPHA311+BETA812*s.l(2,12)));
Cq312 = -(s.trq(3,12)-Cq214*S13-Cq313*C13+Fq113*s.dpt(2,13)+Fs112*s.l(2,12));
Cq111 = -(C12*(s.trq(1,12)-Cq113-Fs312*s.l(2,12)-s.dpt(2,13)*(Fq214*S13+Fq313*C13))-S12*(s.trq(2,12)-Cq214*C13+Cq313*S13));
Fs110 = -(s.frc(1,10)-s.m(10)*(ALPHA29*S10-s.l(2,10)*(qdd(10)-OM110*OM210)));
Fs310 = -(s.frc(3,10)-s.m(10)*(ALPHA31*C9+s.l(2,10)*(qd(10)*(OM210-qd(9)*S10)+qdd(9)*C10)));
Cq310 = -(s.trq(3,10)+Fs110*s.l(2,10));
Cq19 = s.trq(2,10)*S10-C10*(s.trq(1,10)-Fs310*s.l(2,10));
Fs18 = -(s.frc(1,8)-s.m(8)*(ALPHA27*S8-s.l(2,8)*(qdd(8)-OM18*OM28)));
Fs38 = -(s.frc(3,8)+s.m(8)*(qdd(6)*S7-ALPHA31*C7-s.l(2,8)*(qd(8)*(OM28-qd(7)*S8)+qdd(7)*C8)));
Cq38 = -(s.trq(3,8)+Fs18*s.l(2,8));
Fq27 = Fs18*S8-C8*(s.frc(2,8)-s.m(8)*(ALPHA27*C8-s.l(2,8)*(qd(8)*qd(8)+OM18*OM18)));
Cq17 = s.trq(2,8)*S8-C8*(s.trq(1,8)-Fs38*s.l(2,8));
Fq26 = -(s.frc(2,6)-qdd(6)*s.m(6)-Fq27*C7+Fs38*S7);
Fs15 = -(s.frc(1,5)-s.m(5)*(ALPHA24*S5-s.l(2,5)*(qdd(5)-OM15*OM25)));
Fs35 = -(s.frc(3,5)-s.m(5)*(ALPHA31*C4+s.l(2,5)*(qd(5)*(OM25-qd(4)*S5)+qdd(4)*C5)));
Cq35 = -(s.trq(3,5)+Fs15*s.l(2,5));
Cq14 = s.trq(2,5)*S5-C5*(s.trq(1,5)-Fs35*s.l(2,5));
Fs13 = -(s.frc(1,3)-s.m(3)*(ALPHA22*S3-s.l(2,3)*(qdd(3)-OM13*OM23)));
Fs33 = -(s.frc(3,3)-s.m(3)*(ALPHA31*C2+s.l(2,3)*(qd(3)*(OM23-qd(2)*S3)+qdd(2)*C3)));
Cq33 = -(s.trq(3,3)+Fs13*s.l(2,3));
Cq12 = s.trq(2,3)*S3-C3*(s.trq(1,3)-Fs33*s.l(2,3));
Fq31 = -(s.frc(3,1)+s.frc(3,6)-s.m(1)*ALPHA31-s.m(6)*ALPHA31-Fq27*S7-Fs310*C9-Fs33*C2-Fs35*C4-Fs38*C7-C11*(Fs312+Fq214*S13+Fq313*C13)+S11*(C12*...
 (s.frc(2,12)-s.m(12)*(ALPHA212+BS512*s.l(2,12))-Fq214*C13+Fq313*S13)-S12*(Fq113+Fs112))-S2*(Fs13*S3-C3*(s.frc(2,3)-s.m(3)*(ALPHA22*C3-s.l(2,3)*(qd(3)...
 *qd(3)+OM13*OM13))))-S4*(Fs15*S5-C5*(s.frc(2,5)-s.m(5)*(ALPHA24*C5-s.l(2,5)*(qd(5)*qd(5)+OM15*OM15))))-S9*(Fs110*S10-C10*(s.frc(2,10)-s.m(10)*(...
 ALPHA29*C10-s.l(2,10)*(qd(10)*qd(10)+OM110*OM110)))));

% = = Block_0_2_0_0_0_0 = = 
 
% Symbolic Outputs  

Qq(1) = Fq31;
Qq(2) = Cq12;
Qq(3) = Cq33;
Qq(4) = Cq14;
Qq(5) = Cq35;
Qq(6) = Fq26;
Qq(7) = Cq17;
Qq(8) = Cq38;
Qq(9) = Cq19;
Qq(10) = Cq310;
Qq(11) = Cq111;
Qq(12) = Cq312;
Qq(13) = Cq113;
Qq(14) = Cq214;
Qq(15) = Cq315;
Qq(16) = -s.trq(2,16);
Qq(17) = -s.frc(3,17);

% ====== END Task 0 ====== 

  

